# .
# browser_preview.rb
#   
# Copyright 2010 by siberas, http://www.siberas.de
# 
# This file is part of WATOBO (Web Application Tool Box)
#        http://watobo.sourceforge.com
# 
# WATOBO is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation version 2 of the License.
# 
# WATOBO is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with WATOBO; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
# .
require 'win32ole'

module Watobo
  module Gui
    include WIN32OLE::VARIANT
    
    class BrowserPreview
      attr_accessor :proxy
      
      def wait(ie)
        while ie.busy == true
          sleep 0.5
        end
      end
      
      def watoboProxy?
        
        @ie = WIN32OLE.new('InternetExplorer.Application')        
        @ie.visible = false
        url = "http://1.2.3.4/&WATOBOPreview=ProxyTest"
        @ie.navigate(url)
        #wait(@ie)
        sleep 2
        begin          
          if @ie.document.body.innerHTML.to_s =~ /PROXY_OK/ then
            @ie.Quit
            return true 
          end
        rescue
          @ie.Quit
          return false
        end
        @ie.Quit
        return false
      end
      
      def show(proxy, request, response)
        
        begin
          hashid = Digest::MD5.hexdigest(response.join)
          
          proxy.addPreview(hashid, response)
          
          @ie = WIN32OLE.new('InternetExplorer.Application')
          
          @ie.menubar=0
          @ie.toolbar=0
          @ie.statusbar=0
          
          @ie.visible = true
          url = request.url + "&WATOBOPreview=#{hashid}"
          @ie.navigate(url)
        rescue => bang
          puts bang
        end
        
      end
      
      
      def initialize(proxy)
        @proxy = proxy
        @ie = nil
        
      end
    end
  end
end