# .
# progress_window.rb
#   
# Copyright 2010 by siberas, http://www.siberas.de
# 
# This file is part of WATOBO (Web Application Tool Box)
#        http://watobo.sourceforge.com
# 
# WATOBO is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation version 2 of the License.
# 
# WATOBO is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with WATOBO; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
# .
module Watobo
  module Gui
    class ProgressWindow < FXTopWindow
      
      
      
      def newProject(project, settings)
        @project = project
        Thread.new(project, settings) { |p, s|
          
          p = Qproject.new(@gui, s)
          @gui.setActiveProject(p)
          begin
            @job.text = "Finishing ..."
            @step.text = "Starting Proxy"
            # now start interception proxy
            cert_path = File.join(@gui.watobo_base, "certificates")
            proxy = InterceptProxy.new(@gui.active_project, cert_path)
            proxy.run
            @gui.iproxy = proxy

            #@step.text = "Check InternetExplorer Proxy Settings"                          
            #@gui.checkProxySettings()
            
          rescue => bang
            puts bang
          ensure
            self.hide
          end
        }
      end
      
      def progress(progress_index, prefs)
        
        @pbar.progress = progress_index
        @pbar.total = prefs[:total] if prefs[:total]
        @titel.text = prefs[:titel_name] if prefs[:titel_name]
        @job.text = prefs[:job_name] if prefs[:job_name]
        if prefs[:step_name]
          
          @step.text = prefs[:step_name] 
        end
      end
      
      
      def initialize(owner, title, total)
        @gui = owner
        
        super( owner, title, nil, nil, DECOR_BORDER, 0, 0, 250, 100, 0, 0, 0, 0, 0, 0)
        
        titel_frame = FXVerticalFrame.new(self, :opts => LAYOUT_FILL_X|LAYOUT_SIDE_TOP)
        prog_frame = FXVerticalFrame.new(self, :opts => LAYOUT_FILL_X|LAYOUT_SIDE_TOP)
        job_frame = FXVerticalFrame.new(self, :opts => LAYOUT_FILL_X|LAYOUT_SIDE_TOP)
        step_frame = FXVerticalFrame.new(self, :opts => LAYOUT_FILL_X|LAYOUT_SIDE_TOP)
        
        @titel = FXLabel.new(titel_frame, title )
        @job = FXLabel.new(job_frame, 'JOB' )
        @step = FXLabel.new(step_frame, 'current step' )
        
        @pbar = FXProgressBar.new(prog_frame, nil, 0, LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK|PROGRESSBAR_HORIZONTAL)
        
        
        @pbar.progress = 0
        @pbar.total = total
        @pbar.barColor=0
        @pbar.barColor=FXRGB(255,0,0)
        
      end
    end
  end
end
