# .
# save_settings.rb
#   
# Copyright 2010 by siberas, http://www.siberas.de
# 
# This file is part of WATOBO (Web Application Tool Box)
#        http://watobo.sourceforge.com
# 
# WATOBO is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation version 2 of the License.
# 
# WATOBO is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with WATOBO; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
# .
module Watobo
  module Utils
    # e.g, save_settings("test-settings.test", 0, "@saved_settings", @saved_settings) 
    
    def Utils.save_settings(file, level, key, val)
      begin
        if file.class.to_s =~ /String/ then
          fh = File.new(file, "w")
        elsif file.class.to_s =~ /File/ then
          fh = file
        end
        
        fh.print " "*(level*2)
        if key then
          key_env = "'#{key}'"
          key_env = ":#{key}" if key.class.to_s =~ /Symbol/
        end
        case val.class.to_s
          
          when /hash/i
          if level == 0 then # #{key} is the name of the root-hash 
            fh.puts "#{key} = {" 
          else
            fh.puts "#{key_env} => {"  
          end
          val.each do |inner_key, inner_val|       
            save_settings(fh, level+1, inner_key, inner_val)
          end
          fh.print " "*(level*2)
          if level == 0 then
            fh.puts "}" 
          else
            fh.puts "},"  
          end
          
          when /string/i
          # quote double quotes
          s = val.gsub("'", "\\\\'")
          #  puts s
          if key then   
            fh.puts "#{key_env} => '#{s}',"
          else    
            fh.puts "'#{s}'," 
          end
          
          when /fixnum/i     
          if key then
            fh.puts "#{key_env} => #{val}," 
          else
            fh.puts "#{val},"
          end
          
          when /array/i
          fh.puts "#{key_env} => ["
          val.each do |element|
            save_settings(fh, level+1, nil, element)
          end
          fh.print " "*(level*2)
          fh.puts "],"
          
          when /(true|false)/i      
          if key then
            fh.puts "#{key_env} => #{val}," 
         #   puts "#{key_env} => #{val},"
          else
            fh.puts "#{val},"
          end
          
          when /NilClass/i
          # ignore
          
          
        else
          #  puts "unknown setting:"
          #    puts val.class.to_s
          #  puts key.class.to_s
          # if key then
          fh.puts "#{key_env} => '#{val.class.to_s}'," 
          # else
          #   fh.puts "#{val},"
          # end
          
          
        end
        fh.close if file.class.to_s =~ /String/
      rescue => bang
        puts "!ERROR: Could not save settings"
        puts bang
      end
    end
    
  end
end
