# .
# start_watobo.rb
#   
# Copyright 2010 by siberas, http://www.siberas.de
# 
# This file is part of WATOBO (Web Application Tool Box)
#        http://watobo.sourceforge.com
# 
# WATOBO is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation version 2 of the License.
# 
# WATOBO is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with WATOBO; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
# .
if __FILE__ == $0
  
  #Thread.abort_on_exception = true
  require 'rubygems'
  begin
    require 'fox16'
  rescue LoadError
    puts "!!! FXRuby is not installed !!!"
    puts "please check the installation tutorial at http://watobo.sourceforge.net"
    exit
  end
  require 'lib/qGui'
  require 'lib/core/watobo_constants'
  require 'lib/utils/load_icon'
  require 'lib/gui/about_watobo'
  
  include Fox
  include Watobo::Utils
  include Watobo::Gui
  
  $version = "0.9.1(96)"
  
  def loadWatoboIcon(application, filename)
    file = File.join(File.expand_path(File.dirname(__FILE__)), Watobo::Core::ICON_PATH, filename)
    loadIcon(application, file)
  end
  application = FXApp.new("Watobo", "The Webapplication Toolbox")
  #application.init(ARGV)
  
  # ICON_SPLASH = loadWatoboIcon(application, "watobo-logo.gif")
  WATOBO_LOGO = loadIcon(application, File.join(File.dirname(__FILE__), "watobo-logo.png"))
  
  ICON_CB_UNCHECKED = loadWatoboIcon(application, "cb_unchecked.ico") 
  ICON_CB_CHECKED = loadWatoboIcon(application, "cb_checked.ico")
  ICON_CB_CHECKED_ORANGE = loadWatoboIcon(application, "cb_checked_orange.ico")
  
  ICON_WATOBO = loadWatoboIcon(application, "watobo.ico")
  
  
  ICON_MANUAL_REQUEST = loadWatoboIcon(application, "applications.ico")
  ICON_MANUAL_REQUEST_MEDIUM = loadWatoboIcon(application, "applications_24x24.ico")
  ICON_LOGIN_WIZZARD =  loadWatoboIcon(application, "User.ico")
  ICON_DIFFER =  loadWatoboIcon(application, "monitor.ico")
  
  ICON_START = loadWatoboIcon(application, "Play.ico")
  ICON_PAUSE = loadWatoboIcon(application, "Pause.ico")
  ICON_REPORT = loadWatoboIcon(application, "Write Document.ico")
  ICON_ADD_PROJECT = loadWatoboIcon(application, "Add.ico")
  ICON_DASHBOARD = loadWatoboIcon(application, "Bandwidth.ico")
  ICON_CONVERSATION = loadWatoboIcon(application, "conversation.ico")
  ICON_TRANSCODER = loadWatoboIcon(application, "calculator.ico")
  ICON_PROJECT = loadWatoboIcon(application, "Web Browser.ico")
  ICON_FUZZER = loadWatoboIcon(application, "Run.ico")
  ICON_FUZZER_MEDIUM = loadWatoboIcon(application, "fuzzer_24x24.ico")
  
  ICON_VULN = loadWatoboIcon(application, "Mr. Bomb.ico")
  ICON_VULN_LOW = loadWatoboIcon(application, "Yellow Ball.ico")
  ICON_VULN_MEDIUM = loadWatoboIcon(application, "Orange Ball.ico")
  ICON_VULN_HIGH = loadWatoboIcon(application, "Red Ball.ico")
  ICON_VULN_CRITICAL = loadWatoboIcon(application, "burn.ico")
  
  ICON_FOLDER = loadWatoboIcon(application, "folder.ico")
  ICON_REQUEST = loadWatoboIcon(application, "transfer.ico")
  ICON_SITE = loadWatoboIcon(application, "server.ico")
  
  ICON_INFO = loadWatoboIcon(application, "info.ico")
  ICON_INFO_INFO = loadWatoboIcon(application, "iChat.ico")
  ICON_INFO_USER = loadWatoboIcon(application, "User.ico")
  
  ICON_HINTS = loadWatoboIcon(application, "advanced.ico")  
  ICON_HINTS_INFO = loadWatoboIcon(application, "Help.ico")
  
  ICON_SEND_REQUEST = loadWatoboIcon(application, "send.ico")
  # ICON_BROWSER_SMALL = loadWatoboIcon(application, "browser_16x16.ico")
  ICON_BROWSER_MEDIUM = loadWatoboIcon(application, "browser_24x24.ico")
  
  settings = Hash.new
  settings[:base_dir] = File.expand_path(File.dirname(__FILE__))
  puts settings[:base_dir]
  puts $0
  
  interface = WatoboMainWindow.new(application, settings)
  application.create   
  
  file = File.join(File.expand_path(File.dirname(__FILE__)), Watobo::Core::FIRST_TIME_FILE)
  if not File.exists?(file)
    first_start_info = Watobo::Gui::AboutWatobo.new(interface)
    if first_start_info.execute != 0 then
      File.new(file, "w")
    else
      exit
    end
  end
  #ico = FXPNGIcon.new(application, open("./watobo-logo.png","rb").read)
  # splash = FXSplashWindow.new(interface, ICON_SPLASH, SPLASH_SHAPED|SPLASH_DESTROY|SPLASH_OWNS_ICON, 2000)
  #splash = FXSplashWindow.new(application, ICON_SPLASH, SPLASH_SIMPLE, 2000)
  # splash.create()
  #splash.show(PLACEMENT_SCREEN)
  
  # TODO: On first start accept licencse form
  #licensefile = "watobo.lic"
  # if not File.exists?(licensefile) then
  
  # workspaceDialog = Watobo::Gui::WorkspaceDialog.new(interface, prefs)
  # if workspaceDialog.execute != 0 then
  
  #puts "have fun"
  # end
  #  end
  
  application.run
  #application.runModalWhileShown(splash)
  #sleep(5)
end

# NOTES
#TODO: Checkout -> self.accelTable.addAccel(fxparseAccel("Ctl-Q"), getApp(), FXSEL(SEL_COMMAND, FXApp::ID_QUIT))